Subject: Re: [PATCH v2 6/7] Holly DTS

From: David Gibson <[email-masked]>
Date: Fri, 11 May 2007 09:54:53 +1000

On Wed, May 09, 2007 at 05:28:18PM +0200, Segher Boessenkool wrote:
> >>>>> Other dts'es are similar. Could be nice
> >>>>> to have a comment next to it if that's the case.
> >>>>
> >>>> Yeah.  There's also this ?? syntax now I believe.
> >>>
> >>> Not quite yet.
> >>
> >> Yes, the idea was raised, but discussion kind of petered out and
> >> nobody (read: me) got around to implementing it.
> >
> > What exactly did this ?? syntax imply?  I must have missed that thread.
> 
> A property in a DTS file can use that to say
> the property should have a value, but it will
> be filled in by the bootwrapper instead (memory
> address/size, or network MAC address, for
> instance).  Presumably the kernel parser would
> complain when it sees the this-is-still-undefined
> marker.
> 
> The original proposal specified the length of
> the property value IIRC, but that isn't necessary
> anymore.

Well.. sort of.  The first cut at the idea is that ? would be
equivalent to zeroes in terms of dtc output, but would act as internal
documentation that that property is supposed to be filled in by the
bootloader.

Refinements to try to enforce that would be nice: easiest is to
replace it with a configurable poison value.  When using asm output,
or with a map file, it might be possible to generate out-of-band
information which we can use to check that the right things are filled
in.

It's not a simply a matter of making the kernel parser recognize the
uninitialized info, because there's no way to encode that in the dtb
itself.

-- 
David Gibson			| I'll have my music baroque, and my code
david AT gibson.dropbear.id.au	| minimalist, thank you.  NOT _the_ _other_
				| _way_ _around_!
http://www.ozlabs.org/~dgibson